module   TIME_ASCII_BCD  (
  input   [7:0] ASCII_RX ,
  input         RESET_N,
  input         CLK ,
  input         LATCH,
  output  [7:0] SS,
  output  [7:0] MM,  
  output  [7:0] HH ,
  output reg TR 
); 

//=======================================================
//  REG/WIRE declarations
//=======================================================
  reg  [7:0]  BYTE   ; 
  reg  [63:0] CLOCK ;
  reg  [7:0]  CM    ; 
  reg  [111:0] CH1   ;	
  
//=======================================================
//  Structural coding
//=======================================================

  assign  SS = { CLOCK[11:8] , CLOCK[3:0] } ; 
  assign  MM = { CLOCK[35:32] , CLOCK[27:24] } ; 
  assign  HH = { CLOCK[59:56] , CLOCK[51:48] } ; 
  
//------    
 always @(negedge RESET_N  or  posedge  CLK )  
 if  ( !RESET_N ) begin 
      CH1   <=0;
      CLOCK <=0; 
		BYTE  <=0; 
		TR    <=0; 
 end 
 else begin
      
      if ( LATCH  ) begin 
			      CH1[111:0]<=  { CH1[103:0 ] , ASCII_RX } ; 
					 // "+IPD" 
					//if  ( CH1[31:0 ] == {32'h2B495044}  ) TR <= 1 ; 
					// //else  TR <= 0 ; 
				                    //{"C","L","O","S","E","D" }  
			      if  ( CH1[47:0] == 48'h434C4F534544  )   
						       CLOCK[63:0] <=  CH1[111:48] ; 
						//		 TR <= 0 ; 
						//	end  
			
	  end  		
end


endmodule 
