
 
 module uart_rx(
input               clk_i,
input               rst_i,
input               ce16_i,
input               ser_i,
output reg [7:0]    rx_data_o,
output    reg     rx_int_o
 		  );
		  
		  

 
reg [7:0]   rx_data;
reg [1:0]   ser_in;
reg [3:0]   count;
reg [3:0]   bit_count;
reg         rx_busy;
 
wire        ce1_mid;
wire        ce1_end;
 
always @(posedge clk_i or negedge rst_i)
begin
    if (!rst_i)
        ser_in <= 2'b11;
    else
        ser_in <= {ser_in[0], ser_i};
end
 
always @(posedge clk_i or negedge rst_i)
begin
    if (!rst_i)
        count <= 4'h0;
    else if ((rx_busy | (ser_in[1] == 1'b0)) & ce16_i)
        count <= count + 1'b1;
    else if (!rx_busy & ce16_i)
        count <= 4'h0;
end
 
assign ce1_mid = ((count == 4'b0111) & ce16_i);
assign ce1_end = ((count == 4'b1111) & ce16_i);
 
always @(posedge clk_i or negedge rst_i)
begin
    if (!rst_i)
        rx_busy <= 1'b0;
    else if (!rx_busy & ce1_mid)
        rx_busy <= 1'b1;
    else if ( rx_busy & ce1_end & (bit_count == 4'd9))
        rx_busy <= 1'b0;
end
 
always @(posedge clk_i or negedge rst_i)
begin
    if (!rst_i)
        bit_count <= 4'h0;
    else if (rx_busy & ce1_mid)
        bit_count <= bit_count + 1'b1;
    else if (!rx_busy)
        bit_count <= 4'h0;
end
 
always @(posedge clk_i or negedge rst_i)
begin
    if (!rst_i)
        rx_data <= 8'h0;
    else if (ce1_mid)
        rx_data <= {ser_in[1], rx_data[7:1]};
end
 
always @(posedge clk_i or negedge rst_i)
begin
    if (!rst_i) begin
        rx_data_o <= 8'h0;
        rx_int_o <= 1'b0;
    end else if (ce1_end & (bit_count == 4'd8)) begin
        rx_data_o <= rx_data;
        rx_int_o <= 1'b1;
    end else
        rx_int_o <= 1'b0;
end
 endmodule 
 
 
 