
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module DE4_BluetoothSPP_Slave(

	//////////// CLOCK //////////
	GCLKIN,
	GCLKOUT_FPGA,
	OSC_50_BANK2,
	OSC_50_BANK3,
	OSC_50_BANK4,
	OSC_50_BANK5,
	OSC_50_BANK6,
	OSC_50_BANK7,
	PLL_CLKIN_p,

	//////////// LED x 8 //////////
	LED,

	//////////// BUTTON x 4, EXT_IO and CPU_RESET_n //////////
	BUTTON,
	CPU_RESET_n,
	EXT_IO,

	//////////// DIP SWITCH x 8 //////////
	SW,

	//////////// SLIDE SWITCH x 4 //////////
	SLIDE_SW,

	//////////// SEG7 //////////
	SEG0_D,
	SEG0_DP,
	SEG1_D,
	SEG1_DP,

	//////////// Fan //////////
	FAN_CTRL,

	//////////// GPIO1, GPIO1 connect to RFS - RF and Sensor //////////
	BT_KEY,
	BT_UART_RX,
	BT_UART_TX,
	LSENSOR_INT,
	LSENSOR_SCL,
	LSENSOR_SDA,
	MPU_AD0_SDO,
	MPU_CS_n,
	MPU_FSYNC,
	MPU_INT,
	MPU_SCL_SCLK,
	MPU_SDA_SDI,
	RH_TEMP_DRDY_n,
	RH_TEMP_I2C_SCL,
	RH_TEMP_I2C_SDA,
	TMD_D,
	UART2USB_CTS,
	UART2USB_RTS,
	UART2USB_RX,
	UART2USB_TX,
	WIFI_EN,
	WIFI_RST_n,
	WIFI_UART0_CTS,
	WIFI_UART0_RTS,
	WIFI_UART0_RX,
	WIFI_UART0_TX,
	WIFI_UART1_RX	
);

//=======================================================
//  PARAMETER declarations
//=======================================================


//=======================================================
//  PORT declarations
//=======================================================

//////////// CLOCK //////////
input 		          		GCLKIN;
output		          		GCLKOUT_FPGA;
input 		          		OSC_50_BANK2;
input 		          		OSC_50_BANK3;
input 		          		OSC_50_BANK4;
input 		          		OSC_50_BANK5;
input 		          		OSC_50_BANK6;
input 		          		OSC_50_BANK7;
input 		          		PLL_CLKIN_p;

//////////// LED x 8 //////////
output		     [7:0]		LED;

//////////// BUTTON x 4, EXT_IO and CPU_RESET_n //////////
input 		     [3:0]		BUTTON;
input 		          		CPU_RESET_n;
inout 		          		EXT_IO;

//////////// DIP SWITCH x 8 //////////
input 		     [7:0]		SW;

//////////// SLIDE SWITCH x 4 //////////
input 		     [3:0]		SLIDE_SW;

//////////// SEG7 //////////
output		     [6:0]		SEG0_D;
output		          		SEG0_DP;
output		     [6:0]		SEG1_D;
output		          		SEG1_DP;

//////////// Fan //////////
output		          		FAN_CTRL;


//////////// GPIO1, GPIO1 connect to RFS - RF and Sensor //////////
inout 		          		BT_KEY;
input 		          		BT_UART_RX;
output		          		BT_UART_TX;
input 		          		LSENSOR_INT;
inout 		          		LSENSOR_SCL;
inout 		          		LSENSOR_SDA;
output		          		MPU_AD0_SDO;
output		          		MPU_CS_n;
output		          		MPU_FSYNC;
input 		          		MPU_INT;
inout 		          		MPU_SCL_SCLK;
inout 		          		MPU_SDA_SDI;
input 		          		RH_TEMP_DRDY_n;
inout 		          		RH_TEMP_I2C_SCL;
inout 		          		RH_TEMP_I2C_SDA;
inout 		     [7:0]		TMD_D;
input 		          		UART2USB_CTS;
output		          		UART2USB_RTS;
input 		          		UART2USB_RX;
output		          		UART2USB_TX;
output		          		WIFI_EN;
output		          		WIFI_RST_n;
input 		          		WIFI_UART0_CTS;
output		          		WIFI_UART0_RTS;
input 		          		WIFI_UART0_RX;
output		          		WIFI_UART0_TX;
input 		          		WIFI_UART1_RX;

//=======================================================
//  REG/WIRE declarations
//=======================================================

assign  BT_UART_TX = txd;
assign  rxd  = BT_UART_RX;
assign  FAN_CTRL = 1;

wire 				rts; // request to send		  
wire 				cts; // clear to send
wire 				rxd;
wire 				txd;
wire	 [7:0]   uart_data;
wire	         rdempty;
wire	         write;
reg	     	   read;
reg	         cnt;
reg 	 [7:0]	LED_inv;
//=======================================================
//  Structural coding
//=======================================================

// UART Controller
uart_control UART0(

	.clk(OSC_50_BANK2),
	.reset_n(BUTTON[0]),
	// tx
	.write(write),
	.writedata(uart_data),

	// rx
	.read(read),
	.readdata(uart_data),
	.rdempty(rdempty),
	//
	.uart_clk_25m(cnt),
	.uart_tx(txd),
	.uart_rx(rxd)
	
);	

//read
always@(posedge OSC_50_BANK2)
begin
  if (~rdempty)
		read <= 1;
  else
		read <= 0;
end
assign  write = ( read & (~rdempty) );

always@(posedge OSC_50_BANK2 or negedge BUTTON[0])
begin
  if(!BUTTON[0])
    LED_inv <= 0;
  else if(BUTTON[0] & write)
  begin
    case(uart_data)
	 10'h30:LED_inv <= LED_inv | 8'd1;
	 10'h31:LED_inv <= LED_inv | 8'd2;
	 10'h32:LED_inv <= LED_inv | 8'd4;
	 10'h33:LED_inv <= LED_inv | 8'd8;
	 10'h34:LED_inv <= LED_inv & 8'he;
	 10'h35:LED_inv <= LED_inv & 8'hd;
	 10'h36:LED_inv <= LED_inv & 8'hb;
	 10'h37:LED_inv <= LED_inv & 8'h7;
	 10'h38:LED_inv <= LED_inv | 8'hf;
	 10'h39:LED_inv <= LED_inv & 8'h0;
	 default : LED_inv <= LED_inv;
	 endcase
  end
  else
    LED_inv <= LED_inv;
end

always@(posedge OSC_50_BANK2)
	cnt <= cnt + 1;

assign LED = ~LED_inv; 


endmodule
