
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module DE4_RFS_SENSOR_RTL(

	//////////// CLOCK //////////
	GCLKIN,
	GCLKOUT_FPGA,
	OSC_50_BANK2,
	OSC_50_BANK3,
	OSC_50_BANK4,
	OSC_50_BANK5,
	OSC_50_BANK6,
	OSC_50_BANK7,
	PLL_CLKIN_p,

	//////////// LED x 8 //////////
	LED,

	//////////// BUTTON x 4, EXT_IO and CPU_RESET_n //////////
	BUTTON,
	CPU_RESET_n,
	EXT_IO,

	//////////// DIP SWITCH x 8 //////////
	SW,

	//////////// SLIDE SWITCH x 4 //////////
	SLIDE_SW,

	//////////// SEG7 //////////
	SEG0_D,
	SEG0_DP,
	SEG1_D,
	SEG1_DP,

	//////////// Fan //////////
	FAN_CTRL,

	//////////// GPIO1, GPIO1 connect to RFS - RF and Sensor //////////
	BT_KEY,
	BT_UART_RX,
	BT_UART_TX,
	LSENSOR_INT,
	LSENSOR_SCL,
	LSENSOR_SDA,
	MPU_AD0_SDO,
	MPU_CS_n,
	MPU_FSYNC,
	MPU_INT,
	MPU_SCL_SCLK,
	MPU_SDA_SDI,
	RH_TEMP_DRDY_n,
	RH_TEMP_I2C_SCL,
	RH_TEMP_I2C_SDA,
	TMD_D,
	UART2USB_CTS,
	UART2USB_RTS,
	UART2USB_RX,
	UART2USB_TX,
	WIFI_EN,
	WIFI_RST_n,
	WIFI_UART0_CTS,
	WIFI_UART0_RTS,
	WIFI_UART0_RX,
	WIFI_UART0_TX,
	WIFI_UART1_RX
);

//=======================================================
//  PARAMETER declarations
//=======================================================


//=======================================================
//  PORT declarations
//=======================================================

//////////// CLOCK //////////
input 		          		GCLKIN;
output		          		GCLKOUT_FPGA;
input 		          		OSC_50_BANK2;
input 		          		OSC_50_BANK3;
input 		          		OSC_50_BANK4;
input 		          		OSC_50_BANK5;
input 		          		OSC_50_BANK6;
input 		          		OSC_50_BANK7;
input 		          		PLL_CLKIN_p;

//////////// LED x 8 //////////
output		     [7:0]		LED;

//////////// BUTTON x 4, EXT_IO and CPU_RESET_n //////////
input 		     [3:0]		BUTTON;
input 		          		CPU_RESET_n;
inout 		          		EXT_IO;

//////////// DIP SWITCH x 8 //////////
input 		     [7:0]		SW;

//////////// SLIDE SWITCH x 4 //////////
input 		     [3:0]		SLIDE_SW;

//////////// SEG7 //////////
output		     [6:0]		SEG0_D;
output		          		SEG0_DP;
output		     [6:0]		SEG1_D;
output		          		SEG1_DP;

//////////// Fan //////////
output		          		FAN_CTRL;

//////////// GPIO1, GPIO1 connect to RFS - RF and Sensor //////////
inout 		          		BT_KEY;
input 		          		BT_UART_RX;
output		          		BT_UART_TX;
input 		          		LSENSOR_INT;
inout 		          		LSENSOR_SCL;
inout 		          		LSENSOR_SDA;
output		          		MPU_AD0_SDO;
output		          		MPU_CS_n;
output		          		MPU_FSYNC;
input 		          		MPU_INT;
inout 		          		MPU_SCL_SCLK;
inout 		          		MPU_SDA_SDI;
input 		          		RH_TEMP_DRDY_n;
inout 		          		RH_TEMP_I2C_SCL;
inout 		          		RH_TEMP_I2C_SDA;
inout 		     [7:0]		TMD_D;
input 		          		UART2USB_CTS;
output		          		UART2USB_RTS;
input 		          		UART2USB_RX;
output		          		UART2USB_TX;
output		          		WIFI_EN;
output		          		WIFI_RST_n;
input 		          		WIFI_UART0_CTS;
output		          		WIFI_UART0_RTS;
input 		          		WIFI_UART0_RX;
output		          		WIFI_UART0_TX;
input 		          		WIFI_UART1_RX;

//=======================================================
//  REG/WIRE declarations
//======================================================
   wire       RESET_N ; 
   wire [7:0] POWERUP	 ; 
   
   wire [15:0] DATA0  ; 
   wire [15:0] DATA1  ; 
   wire        HM_TR ;
	wire [15:0] HM_XOUT;
	wire [15:0] HM_YOUT;
	wire [15:0] HM_ZOUT;	
 	wire [15:0] ACCEL_XOUT;
	wire [15:0] ACCEL_YOUT;
	wire [15:0] ACCEL_ZOUT;
	wire [15:0] TEMP_OUT;
	wire [15:0] GYRO_XOUT;
	wire [15:0] GYRO_YOUT;
	wire [15:0] GYRO_ZOUT;
	wire [7:0 ] INT_STATUS;  
   wire [2:0] LEDR ; 
   wire [7:0] Temperature_S ; 
   wire [7:0] Humidity_S  ; 	
	
	
	
//=======================================================
//  Structural coding
//=======================================================
//--INITIAL  ---- 
assign FAN_CTRL = 1; 
assign { SEG1_DP , SEG0_DP } =2'b11 ;  

//---- RESET ---
assign RESET_N =BUTTON[0];
//----Humidity -Temperature SENSOR ---	
HC1000 HC(
      .RESET_N        (RESET_N        ),
      .CLOCK_50       (OSC_50_BANK2       ),
      .RH_TEMP_DRDY_n (RH_TEMP_DRDY_n ),
      .RH_TEMP_I2C_SCL(RH_TEMP_I2C_SCL), 
      .RH_TEMP_I2C_SDA(RH_TEMP_I2C_SDA),
      .Temperature_S  (Temperature_S ) , 
      .Humidity_S  	 (Humidity_S  	)	
);		
	
//----LIGHT SENSOR ---	
APDS_9301 ctl( 
   //--SYSTEM--   
	.RESET_N  (RESET_N),
   .CLK_50   (OSC_50_BANK2),
	//--IC SIDE-- 
	.RDY_n    (LSENSOR_INT),   
	.I2C_SCL  (LSENSOR_SCL),
	.I2C_SDA  ( LSENSOR_SDA), 
	.DATA0    (DATA0 ),
	.DATA1    (DATA1 ),
   .POWERUP  (POWERUP) 
	);


//---- RESET ---
	
assign MPU_AD0_SDO =0;
assign MPU_CS_n    =1; 
assign MPU_FSYNC   =0; 
//----Humidity_Temperature ---	
MPU_9250  ctlPP( 
   //--SYSTEM-- 
	.RESET_N 	 ( RESET_N ),
   .CLK_50      ( OSC_50_BANK2 ),
	//--IC SIDE--
	.RDY_n       ( MPU_INT),   
	.I2C_SCL     ( MPU_SCL_SCLK),
	.I2C_SDA     ( MPU_SDA_SDI ),
	.ACCEL_XOUT  ( ACCEL_XOUT),
	.ACCEL_YOUT  ( ACCEL_YOUT),
	.ACCEL_ZOUT  ( ACCEL_ZOUT),
	.TEMP_OUT    ( TEMP_OUT  ),
	.GYRO_XOUT   ( GYRO_XOUT ),
	.GYRO_YOUT   ( GYRO_YOUT ),
	.GYRO_ZOUT   ( GYRO_ZOUT ),
	.INT_STATUS  ( INT_STATUS ),
	.HM_XOUT     ( HM_XOUT),
	.HM_YOUT     ( HM_YOUT),
	.HM_ZOUT     ( HM_ZOUT),
	.TR          ( HM_TR  ) ,	
	
	);

//----------------2 HEX VIEW ------------------------------------------------------
//SW:0   temperature (positive) in decimal     
//SW:1   humidity (positive) in decimal     
//SW:2   LIGHT SENSOR ADC0 (DATA0) MSB 16-bit hexadecimal (positive)
//SW:3   LIGHT SENSOR ADC1 (DATA1) MSB 16-bit hexadecimal (positive)
//SW:4   THREE-AXIS MEMS ACCELEROMETER X MSB 16-bit hexadecimal (positive/negative)
//SW:5   THREE-AXIS MEMS ACCELEROMETER Y MSB 16-bit hexadecimal (positive/negative)
//SW:6   THREE-AXIS MEMS ACCELEROMETER Z MSB 16-bit hexadecimal (positive/negative)
//SW:7   THREE-AXIS MEMS GYROSCOPE     X MSB 16-bit hexadecimal (positive/negative)
//SW:8   THREE-AXIS MEMS GYROSCOPE     Y MSB 16-bit hexadecimal (positive/negative)
//SW:9   THREE-AXIS MEMS GYROSCOPE     Z MSB 16-bit hexadecimal (positive/negative)
//SW:10  THREE-AXIS MEMS MAGNETOMETER  X MSB 16-bit hexadecimal (positive/negative)
//SW:11  THREE-AXIS MEMS MAGNETOMETER  Y MSB 16-bit hexadecimal (positive/negative)
//SW:12  THREE-AXIS MEMS MAGNETOMETER  Z MSB 16-bit hexadecimal (positive/negative)
//SW:13~ 0
//---------------------------------------------------------------------------------	


//-----------Signaltape VIEW-------------------------------------------------------
//SW:0   Temperature       (positive) in decimal   
//SW:1   Humidity          (positive) in decimal  
//SW:2   LIGHT SENSOR ADC0 (DATA0)   (positive) in decimal
//SW:3   LIGHT SENSOR ADC1 (DATA1)   (positive) in decimal
//SW:4   Accelerometer X  (positive/negative) in decimal
//SW:5   Accelerometer Y  (positive/negative) in decimal
//SW:6   Accelerometer Z  (positive/negative) in decimal
//SW:7   Gyroscope X     (positive/negative) in decimal
//SW:8   Gyroscope Y     (positive/negative) in decimal
//SW:9   Gyroscope Z     (positive/negative) in decimal
//SW:10  Magnetometer X  (positive/negative) in decimal
//SW:11  Magnetometer Y  (positive/negative) in decimal
//SW:12  Magnetometer Z  (positive/negative) in decimal
//SW:13~ 0
//----------------------------------------------------------------------------------

HEX_SWITCH  swh(

	.Temperature       ( Temperature_S ) , 
   .Humidity          ( Humidity_S    )	,
	.LIGHT_SENSOR_ADC0 ( DATA0 ),
	.LIGHT_SENSOR_ADC1 ( DATA1 ),
 	.Accelerometer_X   ( ACCEL_XOUT),
	.Accelerometer_Y   ( ACCEL_YOUT),
	.Accelerometer_Z   ( ACCEL_ZOUT),
	.Gyroscope_X       ( GYRO_XOUT ),
	.Gyroscope_Y       ( GYRO_YOUT ),
	.Gyroscope_Z       ( GYRO_ZOUT ),
	.Magnetometer_X    ( HM_XOUT   ),
	.Magnetometer_Y    ( HM_YOUT   ),
	.Magnetometer_Z    ( HM_ZOUT   ),

   .OSC_50            ( OSC_50_BANK2 ) ,
   .SW                ( SLIDE_SW     ), 
	
	.RH_TEMP_DRDY_n    ( RH_TEMP_DRDY_n),
	.POWERUP           ( POWERUP ), 
	.HM_TR             ( HM_TR   ), 
 	.HEX0              ( SEG0_D  ),
	.HEX1              ( SEG1_D  ),
	.LEDR              ( LEDR   ),
	.RESULT            ( ) ,
	.SP_CLK            ( ) 
); 
//---LED DISPLAY  { RH_TEMP_DRDY_n , POWERUP , HM_TR };
assign LED = 8'hff ^ { 5'h00, LEDR[2:0]  };

endmodule
