
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module WiFi_Network_Time(

    //////////// CLOCK //////////
    GCLKIN,
    GCLKOUT_FPGA,
    OSC_50_BANK2,
    OSC_50_BANK3,
    OSC_50_BANK4,
    OSC_50_BANK5,
    OSC_50_BANK6,
    OSC_50_BANK7,
    PLL_CLKIN_p,

    //////////// LED x 8 //////////
    LED,

    //////////// BUTTON x 4, EXT_IO and CPU_RESET_n //////////
    BUTTON,
    CPU_RESET_n,
    EXT_IO,

    //////////// DIP SWITCH x 8 //////////
    SW,

    //////////// SLIDE SWITCH x 4 //////////
    SLIDE_SW,

    //////////// SEG7 //////////
    SEG0_D,
    SEG0_DP,
    SEG1_D,
    SEG1_DP,

    //////////// Fan //////////
    FAN_CTRL,

    //////////// GPIO1, GPIO1 connect to RFS - RF and Sensor //////////
    BT_KEY,
    BT_UART_RX,
    BT_UART_TX,
    LSENSOR_INT,
    LSENSOR_SCL,
    LSENSOR_SDA,
    MPU_AD0_SDO,
    MPU_CS_n,
    MPU_FSYNC,
    MPU_INT,
    MPU_SCL_SCLK,
    MPU_SDA_SDI,
    RH_TEMP_DRDY_n,
    RH_TEMP_I2C_SCL,
    RH_TEMP_I2C_SDA,
    TMD_D,
    UART2USB_CTS,
    UART2USB_RTS,
    UART2USB_RX,
    UART2USB_TX,
    WIFI_EN,
    WIFI_RST_n,
    WIFI_UART0_CTS,
    WIFI_UART0_RTS,
    WIFI_UART0_RX,
    WIFI_UART0_TX,
    WIFI_UART1_RX
);

//=======================================================
//  PARAMETER declarations
//=======================================================


//=======================================================
//  PORT declarations
//=======================================================

//////////// CLOCK //////////
input                       GCLKIN;
output                      GCLKOUT_FPGA;
input                       OSC_50_BANK2;
input                       OSC_50_BANK3;
input                       OSC_50_BANK4;
input                       OSC_50_BANK5;
input                       OSC_50_BANK6;
input                       OSC_50_BANK7;
input                       PLL_CLKIN_p;

//////////// LED x 8 //////////
output           [7:0]      LED;

//////////// BUTTON x 4, EXT_IO and CPU_RESET_n //////////
input            [3:0]      BUTTON;
input                       CPU_RESET_n;
inout                       EXT_IO;

//////////// DIP SWITCH x 8 //////////
input            [7:0]      SW;

//////////// SLIDE SWITCH x 4 //////////
input            [3:0]      SLIDE_SW;

//////////// SEG7 //////////
output   reg     [6:0]      SEG0_D;
output   reg                SEG0_DP;
output   reg     [6:0]      SEG1_D;
output   reg                SEG1_DP;

//////////// Fan //////////
output                      FAN_CTRL;


//////////// GPIO1, GPIO1 connect to RFS - RF and Sensor //////////
inout                       BT_KEY;
input                       BT_UART_RX;
output                      BT_UART_TX;
input                       LSENSOR_INT;
inout                       LSENSOR_SCL;
inout                       LSENSOR_SDA;
output                      MPU_AD0_SDO;
output                      MPU_CS_n;
output                      MPU_FSYNC;
input                       MPU_INT;
inout                       MPU_SCL_SCLK;
inout                       MPU_SDA_SDI;
input                       RH_TEMP_DRDY_n;
inout                       RH_TEMP_I2C_SCL;
inout                       RH_TEMP_I2C_SDA;
inout            [7:0]      TMD_D;
input                       UART2USB_CTS;
output                      UART2USB_RTS;
input                       UART2USB_RX;
output                      UART2USB_TX;
output                      WIFI_EN;
output                      WIFI_RST_n;
input                       WIFI_UART0_CTS;
output                      WIFI_UART0_RTS;
input                       WIFI_UART0_RX;
output                      WIFI_UART0_TX;
input                       WIFI_UART1_RX;



//=======================================================
//  REG/WIRE declarations
//=======================================================
wire pio_wifi_reset;

reg [7: 0] HEX0, HEX1, HEX2, HEX3, HEX4, HEX5;
reg [7: 0] mLED = 8'b0;

//=======================================================
//  Structural coding
//=======================================================

assign FAN_CTRL = 1;
assign WIFI_RST_n = BUTTON[0] & pio_wifi_reset;
assign WIFI_EN = 1'b1;

always @ (*) begin
    mLED[6] = ~WIFI_UART0_TX;
    mLED[7] = ~WIFI_UART0_RX;
end
assign LED = ~mLED;

//assign UART2USB_TX = ((SW[0] == 1'b0)? WIFI_UART0_RX: WIFI_UART0_TX);

RFS_WiFi u0(
        .clk_clk(OSC_50_BANK2),                                         //                                clk.clk
        .reset_reset_n(BUTTON[0]),                                      //                              reset.reset_n
        .pio_key_external_connection_export(BUTTON[1]),                 //            key_external_connection.export

        .wifi_uart0_external_connection_rxd(WIFI_UART0_RX),             //     wifi_uart0_external_connection.rxd
        .wifi_uart0_external_connection_txd(WIFI_UART0_TX),             //                                   .txd
        .wifi_uart0_external_connection_cts_n(WIFI_UART0_CTS),          //                                   .cts_n
        .wifi_uart0_external_connection_rts_n(WIFI_UART0_RTS),          //                                   .rts_n

        .seg7_if_0_conduit_end_export({HEX5, HEX4,
                                       HEX3, HEX2,
                                       HEX1, HEX0}),                    //              seg7_if_0_conduit_end.export

        .pio_wifi_reset_external_connection_export(pio_wifi_reset),     // pio_wifi_reset_external_connection.export
        .pio_led_external_connection_export(mLED[3: 0])                  //        pio_led_external_connection.export
    );

always @(*) begin
    case (SLIDE_SW[1: 0])
        2'b11: begin                    //Hour
            SEG0_D <= HEX4[6: 0];
            SEG0_DP <= HEX4[7];
            SEG1_D <= HEX5[6: 0];
            SEG1_DP <= HEX5[7];
        end
        2'b01: begin                    //Minute
            SEG0_D <= HEX2[6: 0];
            SEG0_DP <= HEX2[7];
            SEG1_D <= HEX3[6: 0];
            SEG1_DP <= HEX3[7];
        end
        2'bX0: begin                    //Second
            SEG0_D <= HEX0[6: 0];
            SEG0_DP <= HEX0[7];
            SEG1_D <= HEX1[6: 0];
            SEG1_DP <= HEX1[7];
        end
        default: begin
            SEG0_D <= HEX0[6: 0];
            SEG0_DP <= HEX0[7];
            SEG1_D <= HEX1[6: 0];
            SEG1_DP <= HEX1[7];
        end
    endcase
end

endmodule
